/*******************************************************************************
 * Copyright (c) 2010, 2019 IBM Corporation and others.
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
/**
 * <copyright>
 * </copyright>
 *
 * $Id: DisplayName.java,v 1.1 2010/03/18 06:24:36 cbateman Exp $
 */
package org.eclipse.jst.jsf.facelet.core.internal.registry.taglib.faceletTaglib;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Display Name</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 *     <![CDATA[
 * 
 *       The display-name type contains a short name that is intended
 *       to be displayed by tools. It is used by display-name
 *       elements.  The display name need not be unique.
 * 
 *       Example:
 * 
 *       ...
 *          <display-name xml:lang="en">
 *            Employee Self Service
 *          </display-name>
 * 
 *       The value of the xml:lang attribute is "en" (English) by default.
 * 
 *       ]]>
 *       
 * <!-- end-model-doc -->
 *
 *
 * @see org.eclipse.jst.jsf.facelet.core.internal.registry.taglib.faceletTaglib.FaceletTaglibPackage#getDisplayName()
 * @model extendedMetaData="name='display-nameType' kind='simple'"
 * @generated
 */
public interface DisplayName extends IdentifiableLangStringValue
{
 // DisplayName
} 
