/*******************************************************************************
 * Copyright (c) 2004, 2007 Sybase, Inc. and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     Sybase, Inc. - initial API and implementation
 *******************************************************************************/
package org.eclipse.jst.jsf.facesconfig.ui.preference;


/**
 * 
 * 
 * 
 * Constants for figure dimensions, etc. used in the sample app
 * 
 */

/*package*/ class FigureConstants
{
	/**
	 * 
	 * 
	 * 
	 */

	private FigureConstants()
	{
	    // no external instantiation
	}

	/**
	 * the default dimension of a port anchor
	 */
	public static final int PORT_SIDE = 10; // (int)Math.round( ARROW_SIDE *
											// Math.cos( 30 ) );


	// CR389070: Figures are abbreviating rule figures names and making them
	// unreadable

	/**
	 * the y port spacing value
	 */
	public static final int PORT_SPACING = 2; // ARROW_SIDE / 2;


	// this is the type of port; input or output

	/**
	 * identifies a port that is an input
	 */
	public static int INPUT_PORT = 0;

	/**
	 * identifies a port that is an output
	 */
	public static int OUTPUT_PORT = 1;
}
